use strict;
use warnings;

my $ref_net = $ARGV[0];
my $file_exp = $ARGV[1];
my $score = $ARGV[2];
my $opt = $ARGV[3];
my $out_mod = $ARGV[4];

#DNASE opt: 1, METH opt: 2

my %hash = ();
my %hash_genes = ();
my $count = 0;

open(my $fh, $file_exp) #se abre el archivo a analizar
  or die "Could not open file '$file_exp' $!";

while (my $row = <$fh>) { #lectura del archivo de genes linea por linea
	chomp $row;


	if($row !~ "track"){
		my @split_row = split ("\t", $row);


		if($split_row[3] >= $score){
			if(!exists $hash{$split_row[0]}{$count}){
				my @array = ($split_row[1],$split_row[2],$split_row[3]);
				@{$hash{$split_row[0]}{$count}} = @array;
				$count++;
			}
		}
	}

}

if($opt == 1){
	open FILE_2, ">tmp.tsv";
}

if($opt == 2){
  open FILE_2, ">tmp.tsv";
}

open(my $fh3, $ref_net)
	or die "Could not open file '$ref_net' $!";

while (my $row = <$fh3>) { #lectura del archivo de genes linea por linea
	chomp $row;

	my @coor;
	my $strand;
	my $flag = 0;
	my $flag_2 = 0;
	my $x_aux;
	my @split_row = split("\t",$row);
	if($split_row[3] =~ ";"){
		@coor = split(";",$split_row[3]);
	}else{
		$coor[0] = $split_row[3];
	}

	for(my $i=0; $i<scalar(@coor); $i++){
		my @split_coor = split(",",$coor[$i]);
		for my $x (keys %{$hash{$split_row[4]}}){
			if($split_coor[0] < $hash{$split_row[4]}{$x}[0]){
				if($split_coor[1] > $hash{$split_row[4]}{$x}[0] && $split_coor[1] <= $hash{$split_row[4]}{$x}[1]){
					$flag = 1;
					$flag_2 = 1;
					$x_aux = $x;
				}
				if($split_coor[1] > $hash{$split_row[4]}{$x}[1]){
					$flag = 1;
					$flag_2 = 1;
					$x_aux = $x;
				}
			}

			if($split_coor[0] > $hash{$split_row[4]}{$x}[0]){
				if($hash{$split_row[4]}{$x}[1] > $split_coor[0] && $split_coor[1] >= $hash{$split_row[4]}{$x}[1]){
					$flag = 1;
					$flag_2 = 1;
					$x_aux = $x;
				}
				if($split_coor[1] < $hash{$split_row[4]}{$x}[1]){
					$flag = 1;
					$flag_2 = 1;
					$x_aux = $x;
				}
			}

			if($split_coor[0] == $hash{$split_row[4]}{$x}[0]){
				if($split_coor[0] > $hash{$split_row[4]}{$x}[1]){
					$flag = 1;
					$flag_2 = 1;
					$x_aux = $x;
				}
				if($split_coor[0] < $hash{$split_row[4]}{$x}[1]){
					$flag = 1;
					$flag_2 = 1;
					$x_aux = $x;
				}
				if($split_coor[0] == $hash{$split_row[4]}{$x}[1]){
					$flag = 1;
					$flag_2 = 1;
					$x_aux = $x;
				}
			}

		}


	}
	if($opt == 1){
		if($flag_2 == 1){
			##print FILE_2 "$row\n"; version antigua.
			print FILE_2 "$row\tH\n"; ## version nueva, agrego H para puntaje posterior.
			$flag_2 = 0;
		}
	}elsif($opt == 2){
		if($flag_2 == 0){
			##print FILE_2 "$row\n"; version antigua.
			print FILE_2 "$row\tM\n"; ## version nueva, agrego M para puntaje posterior.
		}else{
			$flag_2 = 0;
		}
	}




}

print "$ref_net\n";
if($opt == 2){
	system ("copy tmp.tsv $out_mod\\filter_dnamethyl.out");
}elsif($opt == 1){
	system ("copy tmp.tsv $out_mod\\filter_dnahypersens.out");
}
system ("del /f $ref_net");
system ("move tmp.tsv $ref_net");

close FILE_2;
