use strict;
use warnings;

my $file_rpkm = $ARGV[0];
my $file_microRNA_net = $ARGV[1];
my $out = $ARGV[2];

my %hash_rpkm = ();


open(my $fh, '<:encoding(UTF-8)', $file_rpkm) #se abre el archivo a analizar
  or die "Could not open file '$file_rpkm' $!";


while (my $row = <$fh>) { #lectura del archivo linea por linea
	chomp $row;

	my @split_row = split ("\t", $row);
	if(!exists $hash_rpkm{$split_row[1]}){
		$hash_rpkm{$split_row[0]} = $split_row[1];
	}else{
		$hash_rpkm{$split_row[0]} = $hash_rpkm{$split_row[0]} + $split_row[1];

	}

}

open FILE,">$out\\output_miRNA_expres.tsv";
open FILE2,">$out\\output_miRNA_no_expres.tsv";

open(my $fh2, '<:encoding(UTF-8)', $file_microRNA_net) #se abre el archivo a analizar
  or die "Could not open file '$file_microRNA_net' $!";


while (my $row = <$fh2>) { #lectura del archivo linea por linea
	chomp $row;
	my @split_row = split ("\t",$row);

	if (exists $hash_rpkm{$split_row[0]}){
		if($hash_rpkm{$split_row[0]} > 0){
			print "$split_row[0]\t$split_row[1]\t*\t*\t*\texpress_regulator\n";
			print FILE "$split_row[0]\t$split_row[1]\t*\t*\t*\texpress_regulator\n";
		}else{
			print "$split_row[0]-->$split_row[1]\t*\t*\t*\tnot_express_regulator\n";
			print FILE2 "$split_row[0]-->$split_row[1]\t*\t*\t*\tnot_express_regulator\n";
		}
	}else{
		print "$split_row[0]-->$split_row[1]\t*\t*\t*\tnot_express_regulator\n";
		print FILE2 "$split_row[0]-->$split_row[1]\t*\t*\t*\tnot_express_regulator\n";
	}

}

close FILE;
close FILE2;
