use strict;
use warnings;

my $connect_filter = $ARGV[0];
my $connect_analysis = $ARGV[1];
my $out_mod = $ARGV[2];

my %hash_filter = ();

open FILE,">$out_mod\\output_connection_analysis_filter.tsv";

open(my $fh, '<:encoding(UTF-8)', $connect_filter) #se abre el archivo a analizar
  or die "Could not open file '$connect_filter' $!";

while (my $row = <$fh>) { #lectura del archivo linea por linea
	chomp $row;
	my @split_row = split ("\t",$row);
	$hash_filter{"$split_row[0]"} = $split_row[1];
}

open(my $fh2, '<:encoding(UTF-8)', $connect_analysis) #se abre el archivo a analizar
  or die "Could not open file '$connect_analysis' $!";

while (my $row = <$fh2>) { #lectura del archivo linea por linea
	chomp $row;
	my @split_row = split ("\t",$row);
	my $key_1 = "$split_row[0]-->$split_row[1]";
	if(exists $hash_filter{$key_1}){
		print FILE "$row\t$hash_filter{$key_1}\n";
	}
}

close FILE;
