use strict;
use warnings;

my $file_toscore = $ARGV[0];
my $out = $ARGV[1];

open(my $fh, '<:encoding(UTF-8)', $file_toscore) #se abre el archivo a analizar
  or die "Could not open file '$file_toscore' $!";

open FILE,">$out\\scored_GRN.tsv";

while (my $row = <$fh>) { #lectura del archivo linea por linea
	chomp $row;
	my @split_row = split ("\t", $row);
	my @split_score = split (";", $split_row[-1]);
	
	my %nodups; #Elimina duplicados del puntaje final
	@nodups{@split_score} = ();
	@split_score = keys %nodups;	
	
	my $count = scalar @split_score;
	print FILE "$split_row[0]\t$split_row[1]\t$count\n";
}

close FILE;
